{
 Projeto itutilib
    Biblioteca de Funes teis da Itexto
 Autor: Henrique Lobo Weissmann
 E-mail: kicolobo@terra.com.br ou kicolobo@itexto.net
 WWW: http://www.itexto.net
 Belo Horizonte, MG

 Verso 1.2

 O que h de novo na verso 1.2
  Ver arquivo historico.txt

 Direitos de uso:
  Todos esto autorizados a distribuir cpias dos arquivos que acompanham esta DLL desde
  que os mesmos no sofram alteraes.
  Esta biblioteca pode (e deve) ser utilizada livremente. Como seu objetivo consiste em
  ajudar no desenvolvimento da comunidade de programadores Delphi (no necessriamente s
  Delphi) no Brasil, no pode de maneira alguma ser vendida sem a prvia autorizao de seu
  autor (ou autores, conforme novas constribuies cheguem).

 Objetivo do projeto:
  Criar uma biblioteca de funes e procedimentos de uso geral dando nfase a programadores
  Delphi (posteriormente, a outras linguagens tambm, o que explica a sua distribuio
  no formato DLL e no como cdigo fonte) para o ambiente Windows.
    Com o passar do tempo, conforme novos recursos forem sendo acrescentados  biblioteca,
  esta dever ter seu cdigo fonte liberado, de modo que programadores iniciantes possam
  utiliz-lo como material didtico.

 Participando do projeto:
    Envie seus procedimentos e funes (caso ainda no existam na biblioteca) para o endereo
  kicolobo@terra.com.br ou kicolobo@itexto.net. Ou, se preferir, visite o site www.itexto.net.
    Caso voc programa em C++ ou qualquer outra linguagem, a traduo deste arquivo para esta
  tambm seria de grande ajuda.
    Encontrando algum problema na utilizao deste material, envie-me um e-mail para que eu
  possa corrig-lo e assim melhor-lo.

 Utilizao da DLL:
  Para utilizar esta DLL, adicione este arquivo em seu projeto.
  A DLL deve se encontrar localizada ou no diretrio System (que nas verses 2000 e XP se
  chama System32) do Windows ou no mesmo diretrio no qual seu aplicativo for executado.
    Atualmente, acredito que esta DLL possa ser utilizada por qualquer verso do Delphi com
  excesso do Octane que ainda no foi testada.
  No que diz respeito a funes ou procedimentos que utilizem como parmetros valores do tipo
  string, ou que devolvam resultados do tipo string, lembre-se sempre de passar tais parmetros
  com variveis do tipo pchar.

 O autor/fornecedor no se responsabiliza pelo uso inadequado ou qualquer tipo de dano causado pelos
 procedimentos e funes presentes nesta DLL.
}

unit exportutilib;

interface
uses classes, controls;

{
 Matemtica (implementada em 1.1)
}
{Converte polegadas em metros (implementado em 1.2)}
function PolegadaPraMetro(polegadas: double): double; stdcall; external 'itutilib.dll';
{Converte metros para polegadas (implementado em 1.2)}
function MetroPraPolegada(Metros: double): double;stdcall; external 'itutilib.dll';
{Retorna o valor do delta de uma equao de segundo grau (implementada em 1.1)}
function deltaequa2(a: double;b: double;c: double):double; stdcall; external 'itutilib.dll';
{Retorna o primeiro valor de uma equao de segundo grau (implementada em 1.1)}
function equa21(a: double; b:double; c:double):double;stdcall;external 'itutilib.dll';
{Retorna o segundo valor de uma equao de segundo grau (implementada em 1.1)}
function equa22(a: double; b:double; c:double):double;stdcall;external 'itutilib.dll';
{Retorna o resultado de um nmero fatorial (implementada em 1.1)}
function fatorial(n:double):double;stdcall;external 'itutilib.dll';

{
  Funes e procedimentos para a manipulao de Strings
}
{Verifica se uma String est representando corretamente um valor do tipo
 Time (implementado em 1.2)}
function StrIsTime(str:string):boolean;stdcall; export 'itutilib.dll';
{SubstituiStr retorna uma String em que todas as ocorrncias da substring
 Antigo sero substitudas pela nova substring Novo.
 Por exemplo:
 SubstituiStr('Eu estou aqui','estou aqui','estou l') retornar
 'Eu estou l'
 (implementado em 1.2)}
function SubstituiStr( Origem, Antigo, Novo : string ) : string; stdcall; external 'itutilib.dll';
{StrToMoedaLocal converte uma varivel do tipo Currency para uma String
 representando a moeda local. Deixando a varivel Local como padro, a
 converso ser feita para a moeda brasileira
 (implementado na verso 1.1)}
function StrToMoedaLocal(valor:currency;Local:integer = $00000416):string;stdcall; external 'itutilib.dll';
{StrSubstituiChar substitui dentro de uma string todas as ocorrencias de um caractere
 antigo (chAntigo) por um novo (chNovo). (1.1)}
function StrSubstituiChar(str:string;chAntigo:char;chNovo:char):string;stdcall; external 'itutilib.dll';
{InverteString retorna uma string de trs para frente.
 Por exemplo: InverteString('casa') retornar 'asac'}
function InverteString(str:string):string;stdcall; external 'itutilib.dll';
{LimpaEspacos apaga todas as ocorrncias do caractere de espao em uma string.
 Por exemplo: LimpaEspacos('Ol, como vai?') retornar 'Ola,comovai?'}
function LimpaEspacos(str:string):string;stdcall; external 'itutilib.dll';
{ExisteStrInLista verifica a ocorrncia de uma determinado valor de String dentro
 de uma varivel do tipo TStringList}
function ExisteStrInLista(str:string;strlist:tstringlist):boolean;stdcall; external 'itutilib.dll';
{StrInListaPos retornar a posio do ponteiro de uma determinada String caso esta
 exista dentro de uma varivel do tipo TStringList.
 Caso o valor de String no exista, esta funo retornar o valor -1}
function StrInListaPos(str:string;strlist:tstringlist):integer;stdcall; external 'itutilib.dll';
{After devolve o resto de uma determinada String aps o valor de string fornecido.
 Por exemplo: after('Ol, como vai?','Ol') retornar ', como vai?'}
function after(const Search, find: string): string;stdcall; external 'itutilib.dll';
{CharPos retorna a primeira posio de um dado caractere dentro de uma String.
 Por exemplo: CharPos('?','Ol, como vai?') retornar o valor 14}
function CharPos(chr:char;str:string):integer;stdcall; external 'itutilib.dll';
{StrIsInteger verifica se um determinado valor de String representa um valor inteiro.
 Por exemplo: StrIsInteger('13') retornar true, e StrIsInteger('13,3') retornar false.}
function StrIsInteger(const s: string):boolean;stdcall; external 'itutilib.dll';
{StrIsFloat verifica se um determinado valor de String representa um valor float, retornando
 true caso afirmativo.}
function StrIsFloat(const s: string):boolean;stdcall; external 'itutilib.dll';
{IsNumVal verifica se o valor representado por uma string  numrico.
 Por exemplo: IsNumVal('23,33') e IsNumVal('24.3') e IsNumVal('34') retornaro true, ao passo
 que IsNumVal('34k'), IsNumVal('Nmero 3') e IsNumVal('dflkj') retornaro false.}
function IsNumVal (StrVal: string): boolean;stdcall; external 'itutilib.dll';
{DecryptMsg decripta uma mensagem encriptada pela funo EncryptMsg.
 DecryptNo corresponde ao valor a ser adicionado a cada caractere da string fornecida.}
function DecryptMsg (Msg1: string; DecryptNo: integer): string; stdcall; external 'itutilib.dll';
{EncryptMsg encripta um valor de string somando ao seu valor o nmero presente na varivel
 EncryptNo}
function EncryptMsg (Msg1: string; EncryptNo: integer): string; stdcall; external 'itutilib.dll';
{Ocorrencias retornar o nmero de vezes em que um caractere ocorre em uma String}
function Ocorrencias (chr:char; str:string):integer; stdcall; external 'itutilib.dll';

{ExcluiStrInLista exclu determinado valor de string (caso exista) de dentro de uma varivel
 do tipo TStringList.
 Por exemplo: ExcluiStrInLista('String',stringlist) apagar todas as ocorrncias da string
 'String' de dentro da varivel stringlist.}
procedure ExcluiStrInLista(str:string;strlist:tstringlist);stdcall; external 'itutilib.dll';
{IntOrdenar ordena em ordem ascendente valores numricos ordenados dentro de uma varivel
 do tipo TStringList.}
procedure IntOrdenar(lista:tstringlist);stdcall; external 'itutilib.dll';

{
  Funes para a manipulao de datas
}
{Retorna a diferena (em dias) entre duas datas.
 (implementado em 1.2)}
function difDias(data1:tdatetime;data2:tdatetime):double;stdcall; external 'itutilib.dll';
{Retorna o dia de uma data (implementada na verso 1.1)}
function Dia(data:tdate):integer;stdcall; external 'itutilib.dll';
{Retorna o ms de uma data (implementada na verso 1.1)}
function Mes(data:tdate):integer;stdcall; external 'itutilib.dll';
{Retorna o ano de uma data (implementada na verso 1.1)}
function Ano(data:tdate):integer;stdcall; external 'itutilib.dll';
{Retorna o sculo ao qual dado ano pertence (implementada na verso 1.1)}
function Seculo(ano:integer):integer;stdcall; external 'itutilib.dll';
{MesmoDia compara duas datas e retorna true caso possuam o mesmo dia
 (implementada na verso 1.1)}
function MesmoDia(data1:tdate;data2:tdate):boolean;stdcall; external 'itutilib.dll';
{MesmoMes compara daus datas e retorna true caso possuam o mesmo ms
 (implementada na verso 1.1)}
function MesmoMes(data1:tdate;data2:tdate):boolean;stdcall; external 'itutilib.dll';
{MesmoAno compara duas datas e retorna true no caso de se encontrarem no mesmo ano
 (implementada na verso 1.1)}
function MesmoAno(data1:tdate;data2:tdate):boolean;stdcall; external 'itutilib.dll';
{TestaData verifica se uma string representa corretamente uma data}
function testadata(const S: string):boolean;stdcall; external 'itutilib.dll';
{MaiorDateTime retorna a maior data fornecida entre data1 e data2}
function MaiorDateTime(data1:tdatetime;data2:tdatetime):tdatetime;stdcall; external 'itutilib.dll';
{MenorDateTime retorna o menor valor entre data1 e data2}
function MenorDateTime(data1:tdatetime;data2:tdatetime):tdatetime;stdcall; external 'itutilib.dll';
{NomedoMes retorna (em portugus) o nome do ms da data fornecida.}
function NomedoMes(data:tdate):string;stdcall; external 'itutilib.dll';
{DiadaSemana retorna (em portugus) o dia da semanda da data fornecida.}
function DiadaSemana(data:tdate):string;stdcall; external 'itutilib.dll';
{FinaldeSemana verifica se uma certa data cai em um final de semana.}
function FinaldeSemana(data:tdate):boolean;stdcall; external 'itutilib.dll';
{AnoBiSexto verifica se um ano  bisexto.}
function AnoBisexto(Ano: Integer): Boolean; stdcall; external 'itutilib.dll';

{
  Manipulao de arquivos
}
{ADOPegaDataSource devolve a propriedade "Data Source" de uma ConnectionString
 (implementado em 1.2)}
function ADOPegaDataSource(connectionstring:string):string;stdcall; external 'itutilib.dll';
{chkExtensao verifica se o arquivo possu a extenso especficada.
 Por exemplo: chkExtensao('c:\autoexec.bat','.exe') retornar false.}
function chkExtensao(arquivo:string; ext:string):boolean;stdcall; external 'itutilib.dll';
{fileSize retorna o tamanho em bytes de um arquivo.}
function fileSize(const FileName: String): LongInt;stdcall; external 'itutilib.dll';
{ArquivosIguaisTexto compara dois arquivos texto e retorna verdadeiro no caso de serem iguais.}
function ArquivosIguaisTexto(arquivo1:string; arquivo2:string): boolean;stdcall; external 'itutilib.dll';
{MudaDataHoraArq altera a data e a hora de um dado arquivo.
 Caso a operao seja feita com sucesso, o valor retornado corresponde a true.}
function MudaDataHoraArq(NomeArq: string; DataHora: TDateTime): boolean;stdcall; external 'itutilib.dll';

{mudaExtensao altera a extenso de um dado arquivo.
 Por exemplo: mudaExtensao('c:\autoexec.bat','.exe') far com que o arquivo c:\autoexec.bat
 passe a se chamar c:\autoexec.exe}
procedure mudaExtensao(arquivo:string; ext:string);stdcall; external 'itutilib.dll';

{
  Sistema
}
{MudarWallpaper muda o papel de parede do Windows. O parmetro Tile especfica se
 o papel deparede dever ser exposto lado a lado (true) ou centralizado (false).
 Em caso de erro, a funo retornar o valor false.
 (implementado em 1.2)}
function MudarWallpaper(arquivo : String; Tile : boolean ):boolean;stdcall;external 'itutilib.dll';
{pegaBiosData retorna a data da BIOS
 (implementado em 1.2)}
function pegaBiosData:string;stdcall;external 'itutilib.dll';
{pegaFontesDir retornar o diretrio em que as fontes do Windows se encontram
 armazenadas.
 (implementado em 1.2)}
function pegaFontesDir:string;stdcall;external 'itutilib.dll';
{mudaDesktop muda o diretrio em que se encontra a rea de trabalho do Windows,
retornando false em caso de erro.
 Pode ser necessrio que o usurio reinicie seu computador para que a alterao
 tenha efeito.
 (implementado em 1.2)}
function mudaDesktop(diretorio:string):boolean;stdcall;external 'itutilib.dll';
{pegaDesktop retorna o diretrio da rea de trabalho do Windows.
 (implementado em 1.2)}
function pegaDesktop:string;stdcall;external 'itutilib.dll';
{mudaFavoritos muda o diretrio em que sero armazenados os "Favoritos" do
 Windows. Para que estas alteraes surtam efeito,  necessrio que o usurio
 reinicie seu computador.
 Em caso de erro, a funo retornar o valor false.
 (implementado em 1.2)}
function mudaFavoritos(diretorio:string):boolean;stdcall;external 'itutilib.dll';
{pegaFavoritos devolve o diretrio em que se encontram guardados os
 "Favoritos" do Windows}
function pegaFavoritos:string;stdcall;external 'itutilib.dll';
{ArquivoTipo retornar o tipo do arquivo especficado
 (p.ex: Aplicativo, DLL, etc.) (implementado em 1.2)}
function ArquivoTipo(arquivo:string):string;stdcall; external 'itutilib.dll';
{ArquivoNomeDos retorna o nome que o arquivo possu em modo MS-DOS
 (implementado em 1.2)}
function ArquivoNomeDos(arquivo:string):string; stdcall; external 'itutilib.dll';
{ArquivoUltimaModificacao retorna a data em que o arquivo especificado foi
 modificado pela ltima vez (implementado em 1.2)}
function ArquivoUltimaModificacao(arquivo:string):tdatetime; stdcall; external 'itutilib.dll';
{ArquivoUltimoAcesso retornar a data em que o arquivo especficado foi
 acessado pela ltima vez. (implementado em 1.2)}
function ArquivoUltimoAcesso(arquivo:string):tdatetime; stdcall; external 'itutilib.dll';
{ArquivoVersao retorna o nmero de verso de um arquivo do tipo DLL ou Executvel.
 Caso no haja nmero de verso, a funo retornar uma Stirng nula.
 (implementado em 1.2)}
function ArquivoVersao(arquivo:string):string; stdcall; external 'itutilib.dll';
{ArquivoDataCriacao retorna a data na qual o arquivo especificado foi criado
 (implementado em 1.2)}
function ArquivoDataCriacao(arquivo:string):tdatetime; stdcall; external 'itutilib.dll';
{InternetAtiva retorna true caso o computador local esteja conectado
  Internet. (implementado em 1.2)}
function InternetAtiva: Boolean; stdcall; external 'itutilib.dll';
{ADOCompact cria uma cpia compactada do arquivo, armazenada no arquivo destino e retorna
 true caso bem sucedida
 (implementado em 1.1}
function ADOCompact(origem:string;destino:string):boolean; stdcall; external 'itutilib.dll';
{ADOCompactReplace compacta o banco de dados sem criar uma cpia de backup, retornando
 true caso bem suceidda (implementado em 1.1}
function ADOCompactReplace(arquivo:string):boolean; stdcall; external 'itutilib.dll';
{ADOVersao verifica a existncia da biblioteca ADO em um computador.
 Caso esta no esteja instalada, a funo retornar o valor 0.0, caso contrrio,
 a verso da biblioteca instalada ser sua resposta. (implementado em 1.1)}
function ADOVersao: real; stdcall; external 'itutilib.dll';
{SysWinDir retorna o diretrio do Windows (normalmente C:\Windows)}
function SysWinDir: string; stdcall; external 'itutilib.dll';
{SysTempDir retorna o diretrio temporrio do Windows}
function SysTempDir: string; stdcall; external 'itutilib.dll';
{SystemDir retorna o diretrio System (ou System32, nos Windows 2000 e XP)}
function SystemDir: string; stdcall; external 'itutilib.dll';
{NomeroSerieRede retorna o nmero de srie de um disco dentro de uma rede.
 Path fornece o endereo de rede (por exemplo //computador//c:). Deixando Path como nil,
 tm o mesmo efeito que a funo NumeroSerieLocal}
function NumeroSerieRede(const Drive: Char; Path: PChar = nil): Cardinal; stdcall; external 'itutilib.dll';
{NumeroSerieLocal retorna o nmero de srie de um disco}
function NumeroSerieLocal(Unidade:PChar):String; stdcall; external 'itutilib.dll';
{PorcentoLivre retorna a porcentagem de espao livre dentro de um disco local.}
function PorcentoLivre(unidade: byte): Integer; stdcall; external 'itutilib.dll';

implementation

end.
