unit fMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, DBTables, uEstSearchDialog, uEstSearchDialogBde, StdCtrls,
  Mask, DBCtrls, ComCtrls, ExtCtrls, Grids, DBGrids, ADODB,
  uEstSearchDialogAdo, uEstSearchDialogConst, Menus,
  fSimpleSearch, fComplexSearch, fFilteredSearch, fLooksAndBehaviour,
  fLimitedSearch, fNonModalSearch;

type
  TFrmMain = class(TForm)
    mnuMain: TMainMenu;
    mniProgram: TMenuItem;
    mniDemo: TMenuItem;
    mniSimplesearch: TMenuItem;
    mniComplexsearch: TMenuItem;
    mniFilteredsearch: TMenuItem;
    mniLooksandbehaviour: TMenuItem;
    mniClose: TMenuItem;
    mniLimitedsearch: TMenuItem;
    mniNonmodalsearch: TMenuItem;
    procedure mniCloseClick(Sender: TObject);
    procedure mniSimplesearchClick(Sender: TObject);
    procedure mniComplexsearchClick(Sender: TObject);
    procedure mniFilteredsearchClick(Sender: TObject);
    procedure mniLooksandbehaviourClick(Sender: TObject);
    procedure mniLimitedsearchClick(Sender: TObject);
    procedure mniNonmodalsearchClick(Sender: TObject);
  private
  public
  end;

var
  FrmMain: TFrmMain;

implementation

{$R *.dfm}

procedure TFrmMain.mniCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TFrmMain.mniSimplesearchClick(Sender: TObject);
begin
  TFrmSimpleSearch.Create(Application);
end;

procedure TFrmMain.mniComplexsearchClick(Sender: TObject);
begin
  TFrmComplexSearch.Create(Application);
end;

procedure TFrmMain.mniFilteredsearchClick(Sender: TObject);
begin
  TFrmFilteredSearch.Create(Application);
end;

procedure TFrmMain.mniLooksandbehaviourClick(Sender: TObject);
begin
  TFrmLooksAndBehaviour.Create(Application);
end;

procedure TFrmMain.mniLimitedsearchClick(Sender: TObject);
begin
  TFrmLimitedSearch.Create(Application);
end;

procedure TFrmMain.mniNonmodalsearchClick(Sender: TObject);
begin
  TFrmNonModalSearch.Create(Application);
end;

end.
